#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <sys/io.h>
#include <stdlib.h>

#include "IOPort.h"
#include "AtoiHex.h"

int MainFunLayer, FunLayer[2], FunLocation, PrgDisplay;
unsigned long ParPort_Base;
char ResultString[2][1024];

int Getch(void)
{
  int ch;
  struct termios oldt,newt;

  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ECHO|ICANON);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  ch = getchar();
  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);

  return ch;
}

void SubPrgResult(void)
{
  int Result_Row, File_Status;
	FILE *Sub_Prg_Result;
	
	sprintf(ResultString[0], " ");
	sprintf(ResultString[1], " ");
	
	if ((Sub_Prg_Result = fopen("./Function/Result", "r")) != NULL)
	{
		Result_Row = 0;
		for (File_Status = fscanf(Sub_Prg_Result, "%s", ResultString[Result_Row]);
				 File_Status != EOF;
				 File_Status = fscanf(Sub_Prg_Result, "%s", ResultString[Result_Row]))
		{
			printf("The Line %d of The Result String --> \033[7m%s\033[0m\n", Result_Row + 1, ResultString[Result_Row]);
			Result_Row++;
			if (Result_Row == 2)
				break;
		}
	}
}

void Conl_Fun_Location(int _KeyIn, int _FunLocation)
{
  int UpFlag, DownFlag, LeftFlag, RightFlag, EnterFlag;
  char buf[1024];
  
  UpFlag = 1; DownFlag = 1; LeftFlag = 1; RightFlag = 1; EnterFlag = 1;
  
  /* when in the main layer, not up and down */
  if ((FunLocation & 0x0f) == 0x00)
  {
  	UpFlag = 0;
  	DownFlag = 0;
  }
  
  /* when in the highest layer, not up */
  if ((FunLocation & 0x0f) == 0x01)
  	UpFlag = 0;
  
  /* when in the lowest layer, not down */
  if ((FunLocation & 0x0f) == FunLayer[((FunLocation & 0xf0) >> 4) - 1])
  	DownFlag = 0;
  	
  /* when in the leftest layer, not left */
  if ((FunLocation & 0xf0) == 0x10)
  	LeftFlag = 0;
  	
  /* when in the rightest layer, not right */
  if ((FunLocation & 0xf0) == MainFunLayer)
  	RightFlag = 0;
  
  switch (_KeyIn)
  {
  	case 1:
  		if (UpFlag == 1)
				FunLocation = _FunLocation - 0x01;
  		break;
  		
  	case 2:
			if (DownFlag == 1)
				FunLocation = _FunLocation + 0x01;
  		break;
  		
  	case 3:
			if (LeftFlag == 1)
				FunLocation = (_FunLocation & 0xf0) - 0x10;
  		break;
  		
  	case 4:
			if (RightFlag == 1)
				FunLocation = (_FunLocation & 0xf0) + 0x10;
  		break;
  		
  	case 5:
			if (EnterFlag == 1)
			{
				if ((FunLocation & 0x0f) == 0x00)
					FunLocation = _FunLocation + 0x01;
				else
				{
					sprintf(buf, "./Function/%x\n", FunLocation);
					printf("%s", buf);
					system(buf);
					SubPrgResult();
					sprintf(buf, "./LCMPrint %lx '%s' '%s'\n", ParPort_Base, ResultString[0], ResultString[1]);
					printf("%s", buf);
					system(buf);
					PrgDisplay = 1;
					FunLocation = 0x00;
				}
			}					
  		break;  
  }
}

int Sel_Function(int _KeyIn, int _FunLocation)
{
  char buf[1024];

  if (_FunLocation == 0x00)
  	FunLocation = 0x10;	
  
  if (_FunLocation != 0x00)
  	Conl_Fun_Location(_KeyIn, _FunLocation);
  	
  if (PrgDisplay == 0)
  {
	  switch (FunLocation) // menu item
	  {
 	 		case 0x10:
				sprintf(buf, "./LCMPrint %lx '1.0. SYS Inform' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
	  		break;
  			
  		case 0x11:
				sprintf(buf, "./LCMPrint %lx '1.1. Date&Time' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
	  		break;
	  		
	  	case 0x12:
				sprintf(buf, "./LCMPrint %lx '1.2. CPU Inform' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
	  		break;
	  		
	  	case 0x13:
				sprintf(buf, "./LCMPrint %lx '1.3. Memory Inform' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
	  		break;
  		
	  	case 0x14:
				sprintf(buf, "./LCMPrint %lx '1.4. Poweroff' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
	  		break;
  		
 		 	case 0x15:
				sprintf(buf, "./LCMPrint %lx '1.5. Reboot' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
 		 		break;
  		
 		 	case 0x20:
				sprintf(buf, "./LCMPrint %lx '2.0. LAN Inform' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  		
 		 	case 0x21:
				sprintf(buf, "./LCMPrint %lx '2.1. LAN01 IP' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x22:
				sprintf(buf, "./LCMPrint %lx '2.2. LAN02 IP' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  		
		  case 0x23:
				sprintf(buf, "./LCMPrint %lx '2.3. LAN03 IP' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  		
  		case 0x24:
				sprintf(buf, "./LCMPrint %lx '2.4. LAN04 IP' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x25:
				sprintf(buf, "./LCMPrint %lx '2.5. LAN05 IP' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x26:
				sprintf(buf, "./LCMPrint %lx '2.6. LAN01 MAC' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x27:
				sprintf(buf, "./LCMPrint %lx '2.7. LAN02 MAC' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x28:
				sprintf(buf, "./LCMPrint %lx '2.8. LAN03 MAC' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x29:
				sprintf(buf, "./LCMPrint %lx '2.9. LAN04 MAC' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x2a:
				sprintf(buf, "./LCMPrint %lx '2.a. LAN05 MAC' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x2b:
				sprintf(buf, "./LCMPrint %lx '2.b. UP LANs' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break;
  			
  		case 0x2c:
				sprintf(buf, "./LCMPrint %lx '2.c. DOWN LANs' 'EntKey to Enter'\n", ParPort_Base);
				printf("%s", buf);
				system(buf);
  			break; 
  	}
	}
  
  return 1;
}

int main(int argc, char *argv[])
{
	system("clear\n");
	printf("\n\033[7mCopyright (C) 2008 Advantech Company Design by Marlboro Version 1.0.5\n");
	printf("LCM Module Example Program\033[0m\n\n");
	if (argc < 2 || argv[1][0] == '?')
	{
		printf("\033[7mUSAGE :\033[0m\n");
		printf("	LCMAP [ IO ADDRESS ]\n");
		printf("\033[7mEXAMPLE :\033[0m\n");
		printf("	LCMAP 378\n\n");
		return 0;
	}
	
	unsigned int RegValue_Status_Before, RegValue_Status;
	int InputData_Before, InputData, InputFlag;
	char buf[1024];
	
	InputData_Before = 0;
	InputData = 0;
	
	InputFlag = 0; // input button flag
	
	/* sub function no. in main function */
	FunLayer[0] = 0x05;
	FunLayer[1] = 0x0c;
	
	/* main function no. in lcm prg */
	MainFunLayer = 0x20;
	
	ParPort_Base = atoihex(argv[1]);
	
	PrgDisplay = 0; // run function prg flag
	
	sprintf(buf, "./LCMPrint %lx 'LCM Prg V_1.0.5' 'AnyKey to Enter'\n", ParPort_Base);
	printf("%s", buf);
	system(buf);
	
	FunLocation = 0x00; // initial function location
	
	while(IN_Port(ParPort_Base, 0x01, &RegValue_Status_Before) !=1);
	RegValue_Status_Before = RegValue_Status_Before >> 3;
	
	do
	{
		usleep(100000);
		while(IN_Port(ParPort_Base, 0x01, &RegValue_Status) !=1);
		RegValue_Status = RegValue_Status >> 3;
		
		if (RegValue_Status == 0x0f)
			InputData = 0; // none input
		else if (RegValue_Status == 0x07)
			InputData = 1; // input button up
		else if (RegValue_Status == 0x1f)
			InputData = 2; // input button down
		else if (RegValue_Status == 0x0b)
			InputData = 3; // input button left
		else if (RegValue_Status == 0x0d)
			InputData = 4; // input button right
		else if (RegValue_Status == 0x0e)
			InputData = 5; // input button enter
		else if ((RegValue_Status != 0x1d) ||
							(RegValue_Status != 0x1b) ||
							(RegValue_Status != 0x03) ||
							(RegValue_Status != 0x05) ||
							(RegValue_Status != 0x02) ||
							(RegValue_Status != 0x09))
			InputData = 6; // input double button to exit
			
		if ((InputData == 5) && (PrgDisplay == 1))
			PrgDisplay = 0;

		if ((InputData != 0) && (InputFlag == 0) && (PrgDisplay == 0))
		{
			InputFlag = 1;
			if (InputData != 6)
				if (Sel_Function(InputData, FunLocation) == 0)
					printf("\033[7mSelect Function Error!\033[0m\n\n");
		}
		
		if (InputData == 0)
				InputFlag = 0;
		
	} while (InputData != 6);
	
	sprintf(buf, "./LCMPrint %lx 'Exit LCM Prg...'\n", ParPort_Base);
	printf("%s", buf);
	system(buf);
	
	return 1;
}
